accounts/urls.py
from django.contrib.auth import views as auth_views
from django.urls import path
from django.urls import include, path, reverse_lazy
from .views import signup

urlpatterns = [
    path("login/", auth_views.LoginView.as_view(), name="login"),
    path("logout/", auth_views.LogoutView.as_view(), name="logout"),
    path("signup/", signup, name="signup"),
]

expenses/urls.py
from receipts.views import ReceiptListView
from django.contrib import admin
from django.urls import path
from django.urls import include, path, reverse_lazy

urlpatterns = [
    path("", ReceiptListView.as_view(), name="home"),
    path("__debug__/", include("debug_toolbar.urls")),
    path("admin/", admin.site.urls),
    path("receipts/", include("receipts.urls")),
    path("accounts/", include("accounts.urls")),
]

receipts/urls.py
from django.urls import path
from django.urls import include, path, reverse_lazy
from receipts.views import (
    ReceiptListView,
    ReceiptCreateView,
    AccountListView,
    AccountCreateView,
    ExpenseCategoryListView,
    ExpenseCategoryCreateView,
)

urlpatterns = [
    path("", ReceiptListView.as_view(), name="home"),
    path("create/", ReceiptCreateView.as_view(), name="create_receipt"),
    path(
        "categories/create/",
        ExpenseCategoryCreateView.as_view(),
        name="create_category",
    ),
    path(
        "accounts/create/",
        AccountCreateView.as_view(),
        name="create_account",
    ),
    path(
        "categories/",
        ExpenseCategoryListView.as_view(),
        name="list_categories",
    ),
    path("accounts/", AccountListView.as_view(), name="list_accounts"),
]

accounts/models.py
from django.db import models

# Create your models here.

receipts/models.py
from django.db import models
from django.contrib.auth.models import User

# Create your models here.


class ExpenseCategory(models.Model):
    name = models.CharField(max_length=50, unique=True)
    owner = models.ForeignKey(
        User, related_name="categories", on_delete=models.CASCADE
    )

    def __str__(self):
        return self.name


class Account(models.Model):
    name = models.CharField(max_length=100)
    number = models.CharField(max_length=20)
    owner = models.ForeignKey(
        User, related_name="accounts", on_delete=models.CASCADE
    )

    def __str__(self):
        return self.name


class Receipt(models.Model):
    vendor = models.CharField(max_length=200)
    total = models.DecimalField(max_digits=10, decimal_places=3)
    tax = models.DecimalField(max_digits=10, decimal_places=3)
    date = models.DateTimeField()
    purchaser = models.ForeignKey(
        User, related_name="receipts", on_delete=models.CASCADE
    )
    category = models.ForeignKey(
        ExpenseCategory, related_name="receipts", on_delete=models.CASCADE
    )
    account = models.ForeignKey(
        Account, related_name="receipts", on_delete=models.CASCADE, null=True
    )

accounts/forms.py
from django import forms
from django.contrib.auth.forms import UserCreationForm
from django.contrib.auth.models import User


# class NewUserForm(UserCreationForm):
#     email = forms.EmailField(required=True)

#     class Meta:
#         model = User
#         fields = ("username", "email", "password1", "password2")

#     def save(self, commit=True):
#         user = super(NewUserForm, self).save(commit=False)
#         user.email = self.cleaned_data["email"]
#         if commit:
#             user.save()
#         return user

accounts/views.py
from django.shortcuts import render, redirect
from django.contrib.auth import views as auth_views
from django.contrib.auth.forms import UserCreationForm
from django.contrib.auth import login, authenticate

# Create your views here.


def signup(request):
    if request.method == "POST":
        form = UserCreationForm(request.POST)
        if form.is_valid():
            form.save()
            username = form.cleaned_data.get("username")
            raw_password = form.cleaned_data.get("password1")
            user = authenticate(username=username, password=raw_password)
            login(request, user)
            return redirect("home")
    else:
        form = UserCreationForm()
    return render(request, "registration/signup.html", {"form": form})

receipts/views.py
from django.shortcuts import render, redirect
from django.urls import reverse_lazy
from django.views.generic.list import ListView
from django.views.generic.detail import DetailView
from django.views.generic.edit import CreateView, DeleteView, UpdateView
from receipts.models import Account, ExpenseCategory, Receipt
from django.contrib.auth.mixins import LoginRequiredMixin


# Create your views here.


class ReceiptListView(LoginRequiredMixin, ListView):
    model = Receipt
    template_name = "receipts/list.html"

    def get_queryset(self):
        return Receipt.objects.filter(purchaser=self.request.user)


class ReceiptCreateView(LoginRequiredMixin, CreateView):
    model = Receipt
    template_name = "receipts/new.html"
    fields = ["vendor", "total", "tax", "date", "category", "account"]
    success_url = reverse_lazy("home")

    def form_valid(self, form):
        form.instance.purchaser = self.request.user
        return super().form_valid(form)


class ExpenseCategoryListView(LoginRequiredMixin, ListView):
    model = ExpenseCategory
    template_name = "expense_category/list.html"

    def get_queryset(self):
        return ExpenseCategory.objects.filter(owner=self.request.user)


class ExpenseCategoryCreateView(LoginRequiredMixin, CreateView):
    model = ExpenseCategory
    template_name = "expense_category/new.html"
    fields = ["name"]
    success_url = reverse_lazy("list_categories")

    def form_valid(self, form):
        category = form.save(commit=False)
        category.owner = self.request.user
        category.save()
        return redirect("list_categories")


class AccountListView(LoginRequiredMixin, ListView):
    model = Account
    template_name = "accounts/list.html"

    def get_queryset(self):
        return Account.objects.filter(owner=self.request.user)


class AccountCreateView(LoginRequiredMixin, CreateView):
    model = Account
    template_name = "accounts/new.html"

    fields = ["name", "number"]
    success_url = reverse_lazy("home")

    def form_valid(self, form):
        account = form.save(commit=False)
        account.owner = self.request.user
        account.save()
        return redirect("list_accounts")

accounts/templates/base.html
{% load static %}
<!DOCTYPE html>
<html lang="en">
    <head>
        <meta charset="UTF-8" />
        <meta http-equiv="X-UA-Compatible" content="IE=edge" />
        <meta name="viewport" content="width=device-width, initial-scale=1.0" />
        <title>Receipts</title>
        <link rel="stylesheet" href={% static 'css/app.css' %}>
    </head>
    <body>
        <header>
            <nav>
                <ul>
                    {% if user.is_staff %}
                    <li>
                        <a href="{% url 'admin:index' %}">Admin</a>
                    </li>
                    {% endif %} {% if not user.is_authenticated %}
                    <li>
                        <a href="{% url 'login' %}">Login</a>
                    </li>
                    <li>
                        <a href="{% url 'signup' %}">Sign Up</a>
                    </li>
                    {% endif %} {% if user.is_authenticated %}
                    <li>
                        <a href="{% url 'logout' %}">Logout</a>
                    </li>

                    <li>
                        <a href="{% url 'home' %}">Receipts</a>
                    </li>
                    <li>
                        <a href="{% url 'list_accounts' %}">Accounts</a>
                    </li>
                    <li>
                        <a href="{% url 'list_categories' %}"
                            >Expense Categories</a
                        >
                    </li>
                    <li>
                        <a href="{% url 'create_account' %}">Create Account</a>
                    </li>
                    <li>
                        <a href="{% url 'create_receipt' %}">Create Recipt</a>
                    </li>
                    <li>
                        <a href="{% url 'create_category' %}"
                            >Create Category</a
                        >
                    </li>
                    {% endif %}
                </ul>
            </nav>
            {% block pagination %} {% endblock pagination %}
        </header>
        {% block content %} {% endblock content %}
    </body>
</html>

receipts/templates/accounts/list.html
{% extends "base.html" %}{% block content %}
<main>
    <h1>My Accounts</h1>
    <table>
        <tr>
            <th>Name</th>
            <th>Number</th>
            <th>Number of Receipts</th>
        </tr>

        {% for account in account_list%}
        <tr>
            <td>{{ account.name }}</td>
            <td>{{ account.number }}</td>
            <td>{{ account.receipts.all|length }}</td>
        </tr>
        {% endfor %}
    </table>
</main>
{% endblock content%}

receipts/templates/accounts/new.html
{% extends "base.html" %}{% block content %}
<main>
    <div>
        <h1>Create Account</h1>
        <form method="post">
            {% csrf_token %} {{ form.as_p }}
            <button type="submit">Create</button>
        </form>
    </div>
</main>
{% endblock content %}

receipts/templates/expense_category/list.html
{% extends "base.html" %}{% block content %}
<main>
    <h1>My Categories</h1>
    <table>
        <tr>
            <th>Name</th>
            <th>Number of receipts</th>
        </tr>

        {% for category in expensecategory_list%}
        <tr>
            <td>{{ category.name }}</td>
            <td>{{ category.receipts.all|length }}</td>
        </tr>
        {% endfor %}
    </table>

    <a href = {% url "create_category" %}><button type="button">Create a category</button></a>
</main>
{% endblock content%}

receipts/templates/expense_category/new.html
{% extends "base.html" %}{% block content %}
<main>
    <div>
        <h1>Create Category</h1>
        <form method="post">
            {% csrf_token %} {{ form.as_p }}
            <button type="submit">Create</button>
        </form>
    </div>
</main>
{% endblock content %}

receipts/templates/receipts/list.html
{% extends "base.html" %}{% block content %}
<main>
    <h1>My Receipts</h1>
    <table>
        <tr>
            <th>Vendor</th>
            <th>Total</th>
            <th>Tax</th>
            <th>Date</th>
            <th>Category</th>
            <th>Account</th>
        </tr>

        {% for receipt in receipt_list%}
        <tr>
            <td>{{ receipt.vendor }}</td>
            <td>{{ receipt.total }}</td>
            <td>{{ receipt.tax }}</td>
            <td>{{ receipt.date }}</td>
            <td>{{ receipt.category }}</td>
            <td>{{ receipt.account }}</td>
        </tr>
        {% endfor %}
    </table>
    <a href = {% url "create_receipt" %}><button type="button">Create a receipt</button></a>
    <a href = {% url "create_category" %}><button type="button">Create a category</button></a>
</main>
{% endblock content%}

receipts/templates/receipts/new.html
{% extends "base.html" %}{% block content %}
<main>
    <div>
        <h1>Create Receipt</h1>
        <form method="post">
            {% csrf_token %} {{ form.as_p }}
            <button type="submit">Create</button>
        </form>
    </div>
</main>
{% endblock content %}